<?php

/** 
 * Ceon URI Mappings Manager Admin Create/Manage URIs Index Panel Language Defines.
 *
 * @package     ceon_uri_mappings_manager
 * @author      Conor Kerr <zen-cart.uri-mappings-manager@ceon.net>
 * @copyright   Copyright 2011-2012 Ceon
 * @copyright   Copyright 2003-2007 Zen Cart Development Team
 * @copyright   Portions Copyright 2003 osCommerce
 * @link        http://ceon.net/software/business/zen-cart/uri-mappings-manager
 * @license     http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version     $Id: ceon_umm_create_manage_index.php 1059 2012-10-01 16:43:34Z conor $
 */

define('TEXT_ERROR_MISSING_MAPPING_TEMPLATE', 'You must enter a mapping template!');
define('TEXT_ERROR_INVALID_MAPPING_TEMPLATE', 'The template entered is not valid!');

define('TEXT_MAPPING_TEMPLATE_CHANGE', 'Change the template if desired using the following form.');
define('TEXT_MAPPING_TEMPLATES_CHANGE', 'Change the templates if desired using the following form.');

/**
 * Defines for the index page categories/products panels
 */
define('TEXT_CATEGORIES_PRODUCTS_URI_MAPPINGS', 'Categories/Products URI Mappings');

define('TEXT_DEFAULT_CATEGORIES_PRODUCTS_MAPPING_TEMPLATES_TITLE', 'Default Mapping Templates for Categories/Products');
define('TEXT_DEFAULT_CATEGORIES_PRODUCTS_MAPPING_TEMPLATES_INTRO', 'The mapping &ldquo;templates&rdquo; specified in the textfields below will be the default mapping templates that will be used to create a URI mapping for a category or product whenever &ldquo;auto-generation&rdquo; is being used.');
define('TEXT_DEFAULT_CATEGORIES_PRODUCTS_MAPPING_TEMPLATES_OVERRIDE_INFO', 'All categories/products in the store will use URIs with the specified format, unless the &ldquo;default&rdquo; formats specified here are &ldquo;overridden&rdquo; by a more specific template for a category, as set through the use of the <strong>Manage URIs</strong> section, accessed using the button to the right.');

define('TEXT_LABEL_DEFAULT_CATEGORIES_MAPPING_TEMPLATE', 'Default Categories Template:');
define('TEXT_LABEL_DEFAULT_CATEGORIES_MAPPING_TEMPLATES', 'Default Categories Templates:');
define('TEXT_LABEL_DEFAULT_PRODUCTS_MAPPING_TEMPLATE', 'Default Products Template:');
define('TEXT_LABEL_DEFAULT_PRODUCTS_MAPPING_TEMPLATES', 'Default Products Templates:');
define('TEXT_UPDATE_TEMPLATE', 'Update Template');
define('TEXT_UPDATE_TEMPLATES', 'Update Templates');

define('TEXT_MANAGE_CATEGORY_PRODUCT_URIS_TITLE', 'Manage Category/Product URIs');

define('TEXT_ACCESS_CATEGORIES_LISTING', 'The mappings for categories/products can be created/managed by clicking the following button...');
define('TEXT_CREATE_MANAGE_CATEGORY_PRODUCT_URIS', 'Create/Manage URIs');

define('TEXT_DEFAULT_CATEGORIES_MAPPING_TEMPLATE_ADDED', 'Default %s Categories Mapping Template Added');
define('TEXT_DEFAULT_CATEGORIES_MAPPING_TEMPLATE_UPDATED', 'Default %s Categories Mapping Template Updated');
define('TEXT_DEFAULT_PRODUCTS_MAPPING_TEMPLATE_ADDED', 'Default %s Products Mapping Template Added');
define('TEXT_DEFAULT_PRODUCTS_MAPPING_TEMPLATE_UPDATED', 'Default %s Products Mapping Template Updated');

/**
 * Defines for the index page manufacturers panels
 */
define('TEXT_MANUFACTURERS_URI_MAPPINGS', 'Manufacturers URI Mappings');

define('TEXT_DEFAULT_MANUFACTURERS_MAPPING_TEMPLATE_TITLE', 'Default Mapping Template for Manufacturers');
define('TEXT_DEFAULT_MANUFACTURERS_MAPPING_TEMPLATES_TITLE', 'Default Mapping Templates for Manufacturers');
define('TEXT_DEFAULT_MANUFACTURERS_MAPPING_TEMPLATE_INTRO', 'The mapping &ldquo;template&rdquo; specified in the textfield below will be the default mapping template that will be used to create a URI mapping for a manufacturer whenever &ldquo;auto-generation&rdquo; is being used.');
define('TEXT_DEFAULT_MANUFACTURERS_MAPPING_TEMPLATES_INTRO', 'The mapping &ldquo;templates&rdquo; specified in the textfields below will be the default mapping templates that will be used to create a URI mapping for a manufacturer whenever &ldquo;auto-generation&rdquo; is being used.');
define('TEXT_DEFAULT_MANUFACTURERS_MAPPING_TEMPLATES_INFO', 'All manufacturers in the store will use URIs with the specified format.');

define('TEXT_LABEL_DEFAULT_MANUFACTURERS_MAPPING_TEMPLATE', 'Default Manufacturers Template:');
define('TEXT_LABEL_DEFAULT_MANUFACTURERS_MAPPING_TEMPLATES', 'Default Manufacturers Templates:');

define('TEXT_MANAGE_MANUFACTURER_URIS_TITLE', 'Manage Manufacturer URIs');

define('TEXT_ACCESS_MANUFACTURERS_LISTING', 'The mappings for manufacturers can be created/managed by clicking the following button...');
define('TEXT_CREATE_MANAGE_MANUFACTURER_URIS', 'Create/Manage URIs');

define('TEXT_DEFAULT_MANUFACTURERS_MAPPING_TEMPLATE_ADDED', 'Default %s Manufacturers Mapping Template added');
define('TEXT_DEFAULT_MANUFACTURERS_MAPPING_TEMPLATE_UPDATED', 'Default %s Manufacturers Mapping Template updated');

/**
 * Defines for the index page EZ-Pages panels
 */
define('TEXT_EZ_PAGES_URI_MAPPINGS', 'EZ-Pages URI Mappings');

define('TEXT_EZ_PAGES_MAPPING_TEMPLATE_TITLE', 'Default Mapping Template for EZ-Pages');
define('TEXT_EZ_PAGES_MAPPING_TEMPLATES_TITLE', 'Default Mapping Templates for EZ-Pages');
define('TEXT_EZ_PAGES_MAPPING_TEMPLATE_INTRO', 'The mapping &ldquo;template&rdquo; specified in the textfield below will be the default mapping template that will be used to create a URI mapping for an EZ-Page whenever &ldquo;auto-generation&rdquo; is being used.');
define('TEXT_EZ_PAGES_MAPPING_TEMPLATES_INTRO', 'The mapping &ldquo;templates&rdquo; specified in the textfields below will be the default mapping templates that will be used to create a URI mapping for an EZ-Page whenever &ldquo;auto-generation&rdquo; is being used.');
define('TEXT_EZ_PAGES_MAPPING_TEMPLATES_INFO', 'All EZ-Pages in the store will use URIs with the specified format.');

define('TEXT_LABEL_EZ_PAGES_MAPPING_TEMPLATE', 'Default EZ-Pages Template:');
define('TEXT_LABEL_EZ_PAGES_MAPPING_TEMPLATES', 'Default EZ-Pages Templates:');

define('TEXT_MANAGE_EZ_PAGE_URIS_TITLE', 'Manage EZ-Page URIs');

define('TEXT_ACCESS_EZ_PAGES_LISTING', 'The mappings for EZ-Pages can be created/managed by clicking the following button...');
define('TEXT_CREATE_MANAGE_EZ_PAGE_URIS', 'Create/Manage URIs');

define('TEXT_EZ_PAGES_MAPPING_TEMPLATE_ADDED', '%s EZ-Pages Mapping Template added');
define('TEXT_EZ_PAGES_MAPPING_TEMPLATE_UPDATED', '%s EZ-Pages Mapping Template updated');

/**
 * Defines for the index page other pages panels
 */
define('TEXT_OTHER_PAGES_URI_MAPPINGS', '&ldquo;Other&rdquo; Pages URI Mappings');

define('TEXT_OTHER_PAGES_MAPPING_TEMPLATE_TITLE', 'Default Mapping Template for &ldquo;Other&rdquo; Pages');
define('TEXT_OTHER_PAGES_MAPPING_TEMPLATES_TITLE', 'Default Mapping Templates for &ldquo;Other&rdquo; Pages');
define('TEXT_OTHER_PAGES_MAPPING_TEMPLATES_OTHER_PAGES_DESC', '&ldquo;Other&rdquo; pages are Zen Cart pages which are not category pages, product info pages, EZ-Pages or manufacturer listing pages, but any &ldquo;other&rdquo; page the store can/does use.');
define('TEXT_OTHER_PAGES_MAPPING_TEMPLATE_INTRO', 'The mapping &ldquo;template&rdquo; specified in the textfield below will be the default mapping template that will be used to create a URI mapping for one of these other pages whenever &ldquo;auto-generation&rdquo; is being used.');
define('TEXT_OTHER_PAGES_MAPPING_TEMPLATES_INTRO', 'The mapping &ldquo;templates&rdquo; specified in the textfields below will be the default mapping templates that will be used to create a URI mapping for a page whenever &ldquo;auto-generation&rdquo; is being used.');
define('TEXT_OTHER_PAGES_MAPPING_TEMPLATES_INFO', 'All &ldquo;other&rdquo; pages in the store will use URIs with the specified format.');

define('TEXT_LABEL_OTHER_PAGES_MAPPING_TEMPLATE', 'Default &ldquo;Other&rdquo; Pages Template:');
define('TEXT_LABEL_OTHER_PAGES_MAPPING_TEMPLATES', 'Default &ldquo;Other&rdquo; Pages Templates:');

define('TEXT_MANAGE_OTHER_PAGE_URIS_TITLE', 'Manage Other Page URIs');

define('TEXT_ACCESS_OTHER_PAGES_LISTING', 'The mappings for &ldquo;other&rdquo; pages can be created/managed by clicking the following button...');
define('TEXT_CREATE_MANAGE_OTHER_PAGE_URIS', 'Create/Manage URIs');

define('TEXT_OTHER_PAGES_MAPPING_TEMPLATE_ADDED', '%s &ldquo;Other&rdquo; Pages Mapping Template added');
define('TEXT_OTHER_PAGES_MAPPING_TEMPLATE_UPDATED', '%s &ldquo;Other&rdquo; Pages Mapping Template updated');
